import '../../resources/stylesheets/product-market.css';

import React, { Component } from 'react'

export default class ProductMarket extends Component {
  constructor(props) {
    super(props)
    this.state = {}
  }

  componentDidMount() {
    this.props.getProducts();
    this.props.getPromotions();
  }

  calculateDiscount(price, discount) {
    return (price * (1.00 - discount / 100)).toFixed(2);
  }
  
  render() {
    let products = this.props.products;
    let promotions = this.props.promotions;
    
    products.forEach(prod => {
      promotions.forEach(promo => {
        if (prod.sku === promo.productSku) {
          prod.promo = (promo.discountPercentage * 100);
        }
      });
    });
    
    return (
      <div className="product-market-container">
        <h1 id="product-market-title">Product Market</h1>
        <div className="products-container">
          {this.props.products.map(prod => {
            return (
              <div className="product-item" key={ prod.sku }>
                {prod.productName ?
                  <div>
                    <img id="prod-img" src={ prod.productImageUrl ? prod.productImageUrl : "-no photo-" } />
                    <p id="prod-name">{ prod.productName }</p>
                    <p id="prod-description">{ prod.productDescription }</p>
                    <p id="prod-price">${ prod.price }</p>
                    <p id="prod-promotion">
                      { prod.promo  ? "Order now for " 
                                    + prod.promo 
                                    + "% off, making it " 
                                    + this.calculateDiscount(prod.price, prod.promo) 
                                    + "!" :  "" }
                    </p>
                    <button id="add-to-cart-button">Add to Cart</button>
                  </div>
                : ""}
              </div>
            )
          })}
        </div>
      </div>
    )
  }
}
